<?php declare(strict_types=1);

namespace Infomaker\Everyware\Base;

use Infomaker\Everyware\Support\Str;

class AppConfig
{

    private static $instance;

    private $organisationName;

    private function __construct()
    {
        if (\env('APP_ORGANISATION') === null) {
            throw new \RuntimeException('No organisation name provided in .env');
        }

        $this->organisationName = \env('APP_ORGANISATION');
    }

    public static function getOrganisationName(): string
    {
        return static::getInstance()->organisationName;
    }

    public static function getOrganisationSlug(): string
    {
        return Str::lower(str_replace(' ', '-', static::getInstance()->organisationName));
    }

    private static function getInstance(): self
    {
        if (static::$instance === null) {
            static::$instance = new static();
        }

        return static::$instance;
    }
}
